# Changelog

## 1.4.1

- Reverted performance impomenets from 1.4.0 update, since they are incompatible with Swift 5.0.

## 1.4.0

- Significantly improved performance of `ByteReader`, `LsbBitReader` and `MsbBitReader`.

## 1.3.1

- Improved performance of `ByteReader`'s functions and properties when compiled with Swift 4.2 compiler.

## 1.3.0

- Updated to support Swift 4.2.
- Added `advance(by:)` function to both `LsbBitReader` and `MsbBitReader`.
- Added `write(unsignedNumber:bitsCount:)` function to both `LsbBitWriter` and `MsbBitWriter` (PR #1 by @cowgp).

## 1.2.0

- Updated to support Swift 4.1.
- Added `bytesLeft` and `bytesRead` computed properties to `ByteReader`.
- Added `int(fromBytes:)`, `uint16(fromBytes:)`, `uint32(fromBytes:)`, and `uint64(fromBytes:)` functions to all readers.
- Added `byte(fromBits:)`, `uint16(fromBits:)`, `uint32(fromBits:)`, and `uint64(fromBits:)` functions to `LsbBitReader`
  and `MsbBitReader`, as well as `BitReader` protocol.
- `int(fromBits:)` function now has a precondition that its argument doesn't exceed `Int` bit width.
- Reverted "disable symbol stripping" change from 1.1.1 update, since underlying problem in Carthage was fixed.
- Minor updates to documentation.

## 1.1.1

- Added missing documentation for `bitsLeft` and `bitsRead` computed properties.
- Disabled symbol stripping in archives generated by Carthage and published on GitHub Releases.

## 1.1.0

- Added converting from `ByteReader` initializers to `LsbBitReader` and `MsbBitReader`, as well as `BitReader` protocol.
- Added `bitsLeft` and `bitsRead` computed properties to `LsbBitReader` and `MsbBitReader`, as well as `BitReader`
  protocol.

## 1.0.2

- Fixed several problems causing incorrect preconditions failures.

## 1.0.1

- Improved performance of `bit()`, `bits(count:)` and `int(fromBits:)` functions for both `LsbBitReader` and `MsbBitReader`.
- More consistent behaviour (precondition failures) for situtations when there is not enough data left.
- Small updates to documentation.

## 1.0.0

- `ByteReader` class for reading bytes.
- `BitReader` protocol, `LsbBitReader` and `MsbBitReader` classes for reading bits (and bytes).
- `BitWriter` protocol, `LsbBitWriter` and `MsbBitWriter` classes for writing bits (and bytes).
